using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;
using HttpClientExampleWithHttpClientInterception.Controllers;
using JustEat.HttpClientInterception;
using Microsoft.AspNetCore.Mvc;
using Xunit;

namespace HttpClientExampleWithHttpClientInterception.Tests
{
    public class ValuesControllerTest
    {    
        [Fact]
        public async Task GetTest()
        {
            //Arrange
            List<int> myList = new List<int>() {1, 2, 3, 4, 5};

            HttpRequestInterceptionBuilder builder = new HttpRequestInterceptionBuilder()
                .ForHost("localhost.something.com")
                .ForPath("/v1/numbers")
                .WithJsonContent(myList);
            
            HttpClient client = new HttpClientInterceptorOptions()
                .Register(builder).CreateHttpClient("http://localhost.something.com/v1/");

            ValuesController controller = new ValuesController(client);

            //Act
            IActionResult result = await controller.Get();

            //Assert
            OkObjectResult resultObject = result as OkObjectResult;
            Assert.NotNull(resultObject);

            List<int> numbers = resultObject.Value as List<int>;
            Assert.Equal(5, numbers.Count);
        }
    }
}
